import numpy as np
import matplotlib.pyplot as plt
from scipy.signal import chirp

fs = 200
t0 = 0
t1 = 2
N = int((t1-t0)*fs)

t = np.linspace(t0,t1,N)

up = chirp(t,1,t[-1],20)
down = chirp(t,20,t[-1],1)

_,[ax1,ax2] = plt.subplots(2,1,sharex=True)
ax1.plot(t,up)
ax2.plot(t,down)
ax2.set_xlabel('Time [s]')
plt.savefig('chirps.png')
plt.clf()

ps = np.abs(np.fft.rfft(up,norm='ortho'))**2
freqs = np.fft.rfftfreq(up.size,1.0/fs)
plt.plot(freqs,ps)
plt.xlabel('Frequency [Hz]')
plt.ylabel('Power Spectral Density')
plt.savefig('chirps_psd.png')
plt.clf()
