import numpy as np
from numpy import pi,sin
import matplotlib.pyplot as plt
from scipy.signal import argrelmax

t0 = 0
t1 = 2
fs = 200
N = int((t1-t0)*fs)

t = np.linspace(t0,t1,N)
s = 0.7*sin(2*pi*3*t) + 1.2*sin(2*pi*7*t) + 1.0*sin(2*pi*11*t) + np.random.normal(0.0,1.0,N)

plt.plot(t,s)
plt.xlabel('Time [s]')
plt.savefig('stationary.png')
plt.clf()

ps = np.abs(np.fft.rfft(s,norm='ortho'))**2
freqs = np.fft.rfftfreq(s.size,1.0/fs)

plt.plot(freqs,ps)
plt.xlabel('Frequency [Hz]')
plt.ylabel('Power Spectral Density')
plt.savefig('power_spectral_density.png')
plt.clf()
