import numpy as np
from numpy import pi,sin
import matplotlib.pyplot as plt
from scipy.signal import chirp
from signal_processing.hht import hsa,emd,visualization

t0 = 0
t1 = 4
fs = 1000
N = int((t1-t0)*fs)

t = np.linspace(t0,t1,N)

am1 = 0.5*np.sin(2*np.pi*t)
s1 = (1.5 + am1)*chirp(t,40,t[-1],70)
plt.plot(t,s1)
plt.show()

am2 = t/t1
fm = 5*np.sin(2*np.pi*t)
s2 = (1.0 + am2)*np.sin(2*pi*20*t + fm)
plt.plot(t,s2)
plt.show()

s = s1 + s2

plt.plot(t,s)
plt.xlabel('Time [s]')
plt.show()

imfs = emd.decompose(s)
visualization.plot_emd(s,imfs,t)

widths = np.arange(0,80,0.1)
hs = hsa.hht(s,fs,widths)

plt.pcolor(t,widths,hs)
plt.xlabel('Time [s]')
plt.ylabel('Instantaneous Frequency [Hz]')
plt.colorbar()
plt.show()
