import numpy as np
from numpy import pi,sin
import matplotlib.pyplot as plt
from scipy.signal import hilbert,chirp

t0 = 0
t1 = 2
fs = 10000
N = int((t1-t0)*fs)

t = np.linspace(t0,t1,N)
ampl = 1.0 + 0.2*np.sin(2*np.pi * 4*t)
s = ampl*chirp(t,10,t[-1],20)

plt.clf()
plt.plot(t,s)
plt.xlabel('Time [s]')
plt.savefig('hilbert_signal.png')

hs = hilbert(s)
inst_ampl = np.abs(hs)
inst_phase = np.unwrap(np.angle(hs)) * fs/(2*np.pi)
inst_freq = np.diff(inst_phase)

plt.clf()
_,[ax1,ax2] = plt.subplots(2,1,sharex=True)
ax1.plot(t,inst_ampl)
ax1.set_ylabel('Instantaneous Amplitude')
ax2.plot(t[1:],inst_freq)
ax2.set_xlabel('Time [s]')
ax2.set_ylabel('Instantaneous Frequency [Hz]')
plt.savefig('hilbert_ampl_and_freq.png')
