import numpy as np
import matplotlib.pyplot as plt

x0 = -5
x1 = 5
fs = 1000
N = int((x1-x0)*fs)

x = np.linspace(x0,x1,N)
y = 2*x + 1

num_points = 25
points = [int(n) for n in np.linspace(0.05*N,0.95*N,num_points)]

points_x = x[points] + np.random.normal(0.0,0.5,num_points)
points_y = y[points] + np.random.normal(0.0,0.5,num_points)

y1 = 3*x + 2
y2 = x - 1

plt.plot(x,y,label='y=2x+1')
plt.plot(x,y1,label='y=3x+2')
plt.plot(x,y2,label='y=x-1')
plt.legend()
plt.scatter(points_x,points_y,marker='x',color='r')
plt.savefig('line_fitting.png')
